# ipptransform3d(7)

## Name

ipptransform3d - convert 3d document data to alternate formats

## Synopsis

ipptransform3d [ --help ] [ -d device-uri ] [ -i input/format ] [ -m output/format;machine=name ] [ -o "name=value [... name=value]" ] [ -v ] filename

## Description

ipptransform3d converts the input file into the output format and optionally sends the output to a USB (serial) printer. ipptransform3d is normally run by ippserver(8) to convert document data for printing.

## Options

The following options are recognized by ipptransform3d:

--help
  Shows program help.
-d device-uri
  Specifies an output device as a URI. Currently only the "usbserial" URI scheme is supported, for example "usbserial:///dev/ttyACM0" to send print data to an attached USB printer on Linux.
-i input/format
  Specifies the MIME media type of the input file. Currently the "model/3mf" (3MF) and "application/sla" (STL) MIME media types are supported.
-m output/format;machine=name
  Specifies the MIME media type of the output file. Currently only the "application/g-code" (G-code) MIME media type is supported. The "machine=name" parameter specifies a machine-specific variant such as "ultimaker2".
-o "name=value [... name=value]"
  Specifies one or more named options for the conversion. Currently the "materials-col", "platform-temperature", "print-accuracy", "print-base", "print-quality", and "print-supports" options are supported. See the NAMED OPTIONS section for more information.
-v
  Increases the verbosity for any diagnostics.

## Named Options

The following named options are supported:

materials-col
  Specifies the material(s) to use. Each value is surrounded by curley braces and contains a list of material properties and their values, e.g., '{material-diameter=285 material-type="pla" ...}'. The "material-diameter", "material-fill-density", "material-purpose", "material-rate", "material-rate-units", "material-shell-thickness", "material-temperature", and "material-type" properties are supported.
platform-temperature
  Specifies the temperature of the build platform in degrees Celsius.
print-accuracy
  Specifies the dimensional accuracy requirements for the print. For example, a horizontal accuracy of 0.1mm and vertical accuracy of 0.05mm is '{x-accuracy=100 y-accuracy=100 z-accuracy=50 accuracy-units=um}'.
print-base
  Specifies whether brims, rafts, or skirts should be printed. The values 'none', 'brim', 'raft', and 'skirt' are supported.
print-quality
  Specifies the print quality with value 3 (draft), 4 (normal), or 5 (high/best).
print-supports
  Specifies whether supports are printed. The values 'none', 'material', and 'standard' are supported.

## Diagnostics

ipptransform3d sends all messages to the standard error. Each message is prefixed with "ERROR", "INFO", or "DEBUG" depending on the level of verbosity.

## Exit Status

The ipptransform3d program returns 0 if the input file is converted successfully and 1 otherwise.

## Environment

ipptransform3d recognizes the following environment variables:

CONTENT_TYPE
  Specifies the MIME media type of the input file.
DEVICE_URI
  Specifies the output device as a URI.
DOCUMENT_NAME
  Specifies the title of the input file.
IPP_xxx
  Specifies the value of the "xxx" Job Template attribute, where "xxx" is converted to uppercase. For example, the "materials-col" Job Template attribute is stored as the "IPP_MATERIALS_COL" environment variable.
IPP_xxx_DEFAULT
  Specifies the default value of the corresponding "xxx-default" Printer Description attribute, where "xxx" is converted to uppercase. For example, the "materials-col-default" Printer Description attribute is stored as the "IPP_MATERIALS_COL_DEFAULT" environment variable.
OUTPUT_TYPE
  Specifies the MIME media type of the output file. For 'application/g-code' the "flavor" media type parameter specifies the variant of G-code to produce: 'bfb', 'griffin', 'mach3', 'makerbot', 'reprap' (default), 'reprap-volumatric', and 'ultimaker' are currently supported.
SERVER_LOGLEVEL
  Specifies the log level (verbosity) as "error", "info", or "debug".

## Examples

Print a 3MF file to a G-code printer connected via USB on Linux using the default options:

        ipptransform3d -d usbserial:///dev/usbACM0 -m application/g-code \
            filename.3mf

## See Also

ippdoclint(7), ippserver(8), ipptool(1), ipptransform(7)

## Copyright

Copyright © 2016-2019 by the IEEE-ISTO Printer Working Group. Copyright © 2016-2019 by Apple Inc.